"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var xhr_1 = require("@dojo/core/request/providers/xhr");
var Task_1 = require("@dojo/core/async/Task");
var Base_1 = require("./Base");
var HttpChannel = (function (_super) {
    __extends(HttpChannel, _super);
    function HttpChannel(options) {
        var _this = _super.call(this, options) || this;
        _this._sequence = 1;
        _this._messageBuffer = [];
        return _this;
    }
    HttpChannel.prototype._sendData = function (name, data) {
        var _this = this;
        var id = String(this._sequence++);
        var sessionId = this.sessionId;
        var message = { id: id, sessionId: sessionId, name: name, data: data };
        this._messageBuffer.push(JSON.stringify(message));
        if (this._activeRequest || this._pendingRequest) {
            if (!this._pendingRequest) {
                this._pendingRequest = this._activeRequest.then(function () {
                    _this._pendingRequest = null;
                    return _this._send();
                });
            }
            return this._pendingRequest;
        }
        return this._send();
    };
    HttpChannel.prototype._send = function () {
        var _this = this;
        var sendNextBlock = function () {
            var block = [messages.shift()];
            var size = block[0].length;
            while (messages.length > 0 && size + messages[0].length < exports.maxPostSize) {
                size += messages[0].length;
                block.push(messages.shift());
            }
            return xhr_1.default(_this.url, {
                method: 'POST',
                headers: { 'Content-Type': 'application/json' },
                body: JSON.stringify(block)
            }).then(function () {
                if (messages.length > 0) {
                    return sendNextBlock();
                }
            });
        };
        var messages = this._messageBuffer;
        this._messageBuffer = [];
        this._activeRequest = new Task_1.default(function (resolve, reject) {
            return sendNextBlock().then(function () {
                _this._activeRequest = null;
                resolve();
            }, function (error) {
                _this._activeRequest = null;
                reject(error);
            });
        });
        return this._activeRequest;
    };
    return HttpChannel;
}(Base_1.default));
exports.default = HttpChannel;
//# sourceMappingURL=Http.js.map