import Suite, { SuiteProperties } from '../Suite';
import Test, { TestFunction } from '../Test';
import Executor from '../executors/Executor';
export default function getInterface(executor: Executor): {
    registerSuite(descriptor: ObjectSuiteDescriptor | ObjectSuiteFactory): void;
};
export interface ObjectInterface {
    registerSuite(mainDescriptor: ObjectSuiteDescriptor | ObjectSuiteFactory): void;
}
export declare type NestedSuiteDescriptor = Partial<SuiteProperties> & {
    tests: {
        [name: string]: NestedSuiteDescriptor | TestFunction;
    };
};
export declare type ObjectSuiteDescriptor = NestedSuiteDescriptor & {
    name: string;
};
export interface ObjectSuiteFactory {
    (): ObjectSuiteDescriptor;
}
export declare function isSuiteDescriptorFactory<T>(value: any): value is T;
export declare function createSuite<S extends typeof Suite, T extends typeof Test>(executor: Executor, descriptor: NestedSuiteDescriptor, SuiteClass: S, TestClass: T): Suite;
